/**************************************************************** 
 * Description: 
 * Author: Alex Li
 * Date: 2024-01-23 19:05:51
 * LastEditTime: 2024-01-23 19:40:08
****************************************************************/
#include <iostream>
using namespace std;

int dp[101][10001];  // 创建一个动态规划表，用于存储中间结果。
int tim[101];        // 记录每种草药的采摘时间。
int value[101];      // 记录每种草药的价值。

int main(){
    int m,n;  
    cin >> m >> n; // 读入总时间m和草药数目n。

    // 读入每种草药的采摘时间和价值。
    for(int i = 1; i <= n; i++){
        cin >> tim[i] >> value[i];
    }

    // 使用动态规划求解。
    for (int i = 1; i <= n; i++){    
        for (int j = 1; j <= m; j++){ 
            // 如果当前时间小于第i种草药的采摘时间，无法采摘这种草药。
            if(j < tim[i])        
                dp[i][j] = dp[i-1][j];
            else
                // 计算不采这种草药和采这种草药的价值，并取较大者。
                dp[i][j] = max(dp[i-1][j], dp[i-1][j-tim[i]] + value[i]);
        }
    }

    // 输出在给定时间内能采摘到的草药的最大总价值。
    cout << dp[n][m];  
}
